> For the complete documentation index, see [llms.txt](https://docs.devolutions.net/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.devolutions.net/powershell-universal/powershell-commands/new-udtextbox.md).

# New-UDTextbox

### Synopsis

Textboxes let users enter and edit text.

### Syntax

```powershell
New-UDTextbox [[-Id] <String>] [[-Label] <String>] [[-Placeholder] <String>] [[-Value] <String>] [[-Type] <String>] [-Disabled] [[-Icon] <Object>] [-Autofocus] [-Multiline] [[-Rows] <Int32>] [[-RowsMax] <Int32>] [-FullWidth] [[-Variant] <String>] [[-ClassName] <String>] [[-OnEnter] <Endpoint>] [[-OnBlur] <Endpoint>] [-Shrink] [[-OnValidate] <Endpoint>] [[-HelperText] <String>] [[-OnChange] <Endpoint>] [[-Minimum] <Int32>] [[-Maximum] <Int32>] [[-MaximumLength] <Int32>] [[-Sx] <Hashtable>] [[-Style] <Hashtable>] [[-MaskPattern] <String>] [[-Attributes] <Hashtable>] [<CommonParameters>]
```

### Description

Creates a textbox. Textboxes can be used by themselves or within a New-UDForm.

### Parameters

#### -Id

The ID of the component. It defaults to a random GUID.

```
Required?                    false
Position?                    1
Default value                ([Guid]::NewGuid())
Accept pipeline input?       false
Aliases
Accept wildcard characters?  false
```

#### -Label

A label to show above this textbox.

```
Required?                    false
Position?                    2
Default value
Accept pipeline input?       false
Aliases
Accept wildcard characters?  false
```

#### -Placeholder

A placeholder to place within the text box.

```
Required?                    false
Position?                    3
Default value
Accept pipeline input?       false
Aliases
Accept wildcard characters?  false
```

#### -Value

The current value of the textbox.

```
Required?                    false
Position?                    4
Default value
Accept pipeline input?       false
Aliases
Accept wildcard characters?  false
```

#### -Type

The type of textbox. This can be values such as text, password or email.

```
Required?                    false
Position?                    5
Default value                text
Accept pipeline input?       false
Aliases
Accept wildcard characters?  false

    -Disabled [<SwitchParameter>]
        Whether this textbox is disabled.

Required?                    false
Position?                    named
Default value                False
Accept pipeline input?       false
Aliases
Accept wildcard characters?  false
```

#### -Icon The icon to show next to the textbox. Use New-UDIcon to create an icon.Required?                    falsePosition?                    6Default valueAccept pipeline input?       falseAliasesAccept wildcard characters?  false    -Autofocus \[\<SwitchParameter>]        Whether to autofocus this textbox.Required?                    falsePosition?                    namedDefault value                FalseAccept pipeline input?       falseAliasesAccept wildcard characters?  false    -Multiline \[\<SwitchParameter>]        Creates a multiline textboxRequired?                    falsePosition?                    namedDefault value                FalseAccept pipeline input?       falseAliasesAccept wildcard characters?  false-RowsThe number of rows in a multiline textbox.Required?                    falsePosition?                    7Default value                -1Accept pipeline input?       falseAliasesAccept wildcard characters?  false-RowsMaxThe maximum number of rows in a multiline textbox.Required?                    falsePosition?                    8Default value                9999Accept pipeline input?       falseAliasesAccept wildcard characters?  false    -FullWidth \[\<SwitchParameter>]        Whether to make this textbox take up the full width of the parent control.Required?                    falsePosition?                    namedDefault value                FalseAccept pipeline input?       falseAliasesAccept wildcard characters?  false-VariantThe variant of textbox. Valid values are "filled", "outlined", "standard"Required?                    falsePosition?                    9Default value                standardAccept pipeline input?       falseAliasesAccept wildcard characters?  false-ClassNameA CSS class to apply to the textbox.Required?                    falsePosition?                    10Default valueAccept pipeline input?       falseAliasesAccept wildcard characters?  false-OnEnterA script block that is called when the user presses the enter key. The $EventData variable will contain the current value of the textbox.Required?                    falsePosition?                    11Default valueAccept pipeline input?       falseAliasesAccept wildcard characters?  false-OnBlurA script block that is called when the user leaves the textbox. The $EventData variable will contain the current value of the textbox.Required?                    falsePosition?                    12Default valueAccept pipeline input?       falseAliasesAccept wildcard characters?  false    -Shrink \[\<SwitchParameter>]        Whether to shrink label by default.Required?                    falsePosition?                    namedDefault value                FalseAccept pipeline input?       falseAliasesAccept wildcard characters?  false-OnValidateA script block that is called when the user leaves the textbox. The $EventData variable will contain the current value of the textbox. If the script block returns an validation result that is invalid, it will be displayed below the textbox.Required?                    falsePosition?                    13Default valueAccept pipeline input?       falseAliasesAccept wildcard characters?  false-HelperTextA helper text to show below the textbox.Required?                    falsePosition?                    14Default valueAccept pipeline input?       falseAliasesAccept wildcard characters?  false-OnChangeA script block that is called when the user changes the value of the textbox. The $EventData variable will contain the current value of the textbox.Required?                    falsePosition?                    15Default valueAccept pipeline input?       falseAliasesAccept wildcard characters?  false-MinimumThe minimum value for a number textbox.Required?                    falsePosition?                    16Default value                0Accept pipeline input?       falseAliasesAccept wildcard characters?  false-MaximumThe maximum value for a number textbox.Required?                    falsePosition?                    17Default value                0Accept pipeline input?       falseAliasesAccept wildcard characters?  false-MaximumLengthThe maximum length of the text in the textbox.Required?                    falsePosition?                    18Default value                0Accept pipeline input?       falseAliasesAccept wildcard characters?  false-SxA hashtable of theme-based properties to apply to the textbox.Required?                    falsePosition?                    19Default valueAccept pipeline input?       falseAliasesAccept wildcard characters?  false-StyleA hashtable of CSS properties to apply to the textbox.Required?                    falsePosition?                    20Default valueAccept pipeline input?       falseAliasesAccept wildcard characters?  false-MaskPatternA mask pattern to apply to the textbox. This is used for input masks. Check iMaskjs for more information.Required?                    falsePosition?                    21Default valueAccept pipeline input?       falseAliasesAccept wildcard characters?  false-AttributesRequired?                    falsePosition?                    22Default value                @{}Accept pipeline input?       falseAliasesAccept wildcard characters?  false    \<CommonParameters>        This cmdlet supports the common parameters: Verbose, Debug,        ErrorAction, ErrorVariable, WarningAction, WarningVariable,        OutBuffer, PipelineVariable, and OutVariable. For more information, see        about\_CommonParameters (<https://go.microsoft.com/fwlink/?LinkID=113216).Outputs--------------------------> EXAMPLE 1 --------------------------PS >New-UDTextbox -Id 'textbox1' -Label 'Name' -Placeholder 'Enter your name' -Value 'John Doe'Basic textbox|Creates a basic textbox.-------------------------- EXAMPLE 2 --------------------------PS >New-UDTextbox -Id 'textbox2' -Label 'Password' -Placeholder 'Enter your password' -Type 'password'Password textbox|Creates a password textbox.-------------------------- EXAMPLE 3 --------------------------PS >New-UDTextbox -Id 'textbox3' -Label 'Email' -Placeholder 'Enter your email' -Type 'email'Email textbox|Creates an email textbox.-------------------------- EXAMPLE 4 --------------------------PS >New-UDTextbox -Id 'textbox4' -Disabled -Label 'Disabled' -Placeholder 'Enter your name' -Value 'John Doe'Disabled textbox|Creates a disabled textbox.-------------------------- EXAMPLE 5 --------------------------PS >New-UDTextbox -Id 'textbox5' -Label 'Name' -Placeholder 'Enter your name' -Value 'John Doe' -Icon (New-UDIcon -Icon 'User')Textbox with icon|Creates a textbox with an icon.-------------------------- EXAMPLE 6 --------------------------PS >New-UDTextbox -Id 'textbox6' -Label 'Name' -Placeholder 'Enter your name' -Value 'John Doe' -AutofocusAutofocus textbox|Creates a textbox that will autofocus when the page loads.-------------------------- EXAMPLE 7 --------------------------PS >New-UDTextbox -Id 'textbox7' -Label 'Name' -Placeholder 'Enter your name' -Value 'John Doe' -MultilineMultiline textbox|Creates a multiline textbox.-------------------------- EXAMPLE 8 --------------------------PS >New-UDTextbox -Id 'textbox8' -Label 'Name' -Placeholder 'Enter your name' -Value 'John Doe' -Multiline -Rows 5 -RowsMax 10Multiline textbox with 5 rows|Creates a multiline textbox with 5 rows.-------------------------- EXAMPLE 9 --------------------------PS >New-UDTextbox -Id 'textbox9' -Variant 'filled' -Label 'Name' -Placeholder 'Enter your name' -Value 'John Doe'Variant|Creates a filled textbox.-------------------------- EXAMPLE 10 --------------------------PS >New-UDTextbox -Id 'textbox10' -OnEnter {PS >    Show-UDToast -Message "You pressed enter!"PS > } -Label 'Name' -Placeholder 'Enter your name' -Value 'John Doe'OnEnter|Creates a textbox with an OnEnter event.-------------------------- EXAMPLE 11 --------------------------PS >New-UDTextbox -Id 'textbox11' -OnBlur {PS >    Show-UDToast -Message "You left the textbox!"PS > } -Label 'Name' -Placeholder 'Enter your name' -Value 'John Doe'OnBlur|Creates a textbox with an OnBlur event.-------------------------- EXAMPLE 12 --------------------------PS >New-UDTextbox -Id 'textbox12' -OnValidate {PS >    if ($EventData -eq 'John Doe') {PS >        return New-UDValidationResult -ValidPS >    }PS >    else {PS >        return New-UDValidationResult -ValidationError "You must enter John Doe"PS >    }PS > } -Label 'Name' -Placeholder 'Enter your name' -Value 'John Doe'OnValidate|Creates a textbox with an OnValidate event.-------------------------- EXAMPLE 13 --------------------------PS >New-UDTextbox -Id 'textbox13' -HelperText 'This is a helper text' -Label 'Name' -Placeholder 'Enter your name' -Value 'John Doe'Helper Text|Creates a textbox with helper text.-------------------------- EXAMPLE 14 --------------------------PS >New-UDTextbox -Id 'textbox14' -OnChange {PS >    Show-UDToast -Message $EventDataPS > } -Label 'Name' -Placeholder 'Enter your name' -Value 'John Doe'OnChange|Creates a textbox with an OnChange event.-------------------------- EXAMPLE 15 --------------------------PS >New-UDTextbox -Id 'textbox15' -Type 'number' -Minimum 1 -Maximum 100Minimum and Maximum|Creates a number textbox with a minimum and maximum value.-------------------------- EXAMPLE 16 --------------------------PS >New-UDTextbox -Id 'textbox16' -MaskPattern '+7 (000) 000-00-00'Mask Pattern|Creates a textbox with a mask pattern.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.devolutions.net/powershell-universal/powershell-commands/new-udtextbox.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
